<template>
  <div class="text-center">
    <v-dialog v-model="model" width="500">
      <v-card>
        <v-card-title>Réinitialiser votre mot de passe</v-card-title>
        <v-card-text>
          <v-text-field
            label="Entrer votre adresse email"
            v-model="mail"
            :rules="[rules.required, rules.email]"
          />
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn :disabled="rules.email(mail) === 'E-mail invalide.'" color="blue darken-1" :ripple="false" text @click="sendResetMail">
            <v-icon>mdi-email</v-icon>Envoyer
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </div>
</template>

<script lang="ts">
import { Component, Vue, Prop } from "vue-property-decorator";
import UserService from "../../services/userService";

@Component
export default class ModalMail extends Vue {
  @Prop({ default: false }) model: boolean;
  private _userService: UserService = null;
  private mail: string = "";
  rules = {
    required: value => !!value || "Required.",
    email: value => {
      const pattern = /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
      return pattern.test(value) || "E-mail invalide.";
    }
  };
  mounted() {
    this._userService = new UserService();
  }

  sendResetMail() {
      if (this.rules.email(this.mail) !== "E-mail invalide.") {
        this._userService.sendResetMail(this.mail);
      }
  }
}
</script>

<style>
</style>
